<template>
	<v-layout text-xs-center wrap>
		<v-flex mb-5 xs12>
			<Parallax
				title="welcome"
				:titleExtraValues="{ value: $appName }"
				message="static.motto"
				image="akali01.jpg"
			/>
		</v-flex>
		<v-flex offset-sm3 sm6 xs12>
			<v-card>
				<v-card-actions>
					<v-select :items="items" label="Size" v-model="size"></v-select>
					<v-spacer></v-spacer>
				</v-card-actions>
				<v-container fluid v-bind="{ [`grid-list-${size}`]: true }">
					<v-layout row wrap>
						<v-flex :key="image" v-for="image in imageList" xs4>
							<v-card flat tile>
								<v-img :src="image" height="150px"></v-img>
							</v-card>
						</v-flex>
					</v-layout>
				</v-container>
			</v-card>
		</v-flex>
	</v-layout>
</template>

<script lang="ts">
import Vue from "vue";
import HelloWorld from "@/components/HelloWorld.vue"; // @ is an alias to /src
import mathMixin from "@/mixins/math";
import imageMixin from "@/mixins/image";
import Parallax from "@/components/vuetify/Parallax.vue";
import store from "@/store.ts";
interface Data {
	size: string;
	items: Item[];
}
interface Item {
	text: string;
	value: string;
}

const numberOfImages: number = 12;
export default {
	name: "MainView",
	components: {
		HelloWorld,
		Parallax,
	},
	data(): Data {
		return {
			size: "sm",
			items: [
				{ text: "Extra small (2px)", value: "xs" },
				{ text: "Small (4px)", value: "sm" },
				{ text: "Medium (8px)", value: "md" },
				{ text: "Large (16px)", value: "lg" },
				{ text: "Extra large (24px)", value: "xl" },
			],
		};
	},
	computed: {
		mainBannerImage(): string {
			return store.getters.getAboutState.mainBannerImage;
		},

		imageList(): string[] {
			return store.getters.getAboutState.imageList;
		},
	},
	methods: {
		fillImageList(): string[] {
			let _imageList: string[] = [];
			for (let index = 0; index < numberOfImages; index++) {
				_imageList[index] = this.fetchRandomImage(
					150,
					300,
					this.getRandomNumber()
				);
			}
			return _imageList;
		},
		getMainBannerImage(): string {
			return this.fetchRandomImage(1500, 3000, this.getRandomNumber());
		},
	},
	mixins: [mathMixin, imageMixin],
	mounted() {
		if (this.imageList.length <= 1 && this.mainBannerImage.length < 1) {
			this.$store.commit("setAboutState", {
				mainBannerImage: this.getMainBannerImage(),
				imageList: this.fillImageList(),
			});
		}
	},
};
</script>
<style lang="scss" module>
.list {
	height: 50vh;
}
</style>
